package io.gitlab.jfronny.combit;

import io.gitlab.jfronny.libjf.config.api.Entry;
import io.gitlab.jfronny.libjf.config.api.JfConfig;
import net.fabricmc.loader.api.FabricLoader;

import java.util.HashSet;

public class CombitConfig implements JfConfig {
    // Invulnerability
    @Entry(min = 0) public static Integer iFrameInterval = 0;
    @Entry(max = 1) public static Double attackCancelThreshold = 0.1;
    @Entry(max = 1) public static Double knockbackCancelThreshold = 0.75;
    @Entry public static HashSet<String> attackerWhitelist = null;
    @Entry public static HashSet<String> damageSourceWhitelist = null;
    @Entry public static HashSet<String> targetEntityWhitelist = null;
    @Entry public static Boolean excludeAllMobs = false;
    @Entry public static Boolean excludePlayers = false;
    // Health
    @Entry public static Double entityHealthFactor = 1.5;
    @Entry public static HashSet<String> entityHealthBlacklist = null;
    // Weapons
    @Entry public static Double cooldownProgressOverride = 0.8;
    @Entry public static Double cooldownProgressPerTickOverride = Double.MIN_VALUE;
    @Entry public static Double weaponAttackDamageFactor = 0.6;
    @Entry public static Double axeAttackDamageFactor = 0.5;
    // Debug
    @Entry public static Boolean debug = FabricLoader.getInstance().isDevelopmentEnvironment();
}
